module Appfirst::Collection
  def self.included(klass)
    klass.attribute :next_link
    klass.attribute :prev_link
    klass.attribute :last_link
    klass.attribute :total_count
    klass.attribute :url
    klass.send(:extend, Appfirst::Collection::Attributes)
  end

  module Attributes
    attr_accessor :model_root, :model_request, :collection_root, :collection_request
  end

  def create!(*args)
    model = self.new(*args)
    model.save!
  end

  def model_root
    self.class.model_root
  end

  def model_request
    self.class.model_request
  end

  def get(id)
    if data = connection.send(self.model_request, "id" => id).body[self.model_root]
      new(data)
    else
      nil
    end
  rescue Appfirst::Response::NotFound
    nil
  end

  def collection_root
    self.class.instance_variable_get(:@collection_root)
  end

  def collection_request
    self.class.instance_variable_get(:@collection_request)
  end

  def ==(comparison_object)
    comparison_object.equal?(self) ||
      (comparison_object.is_a?(self.class) &&
       comparison_object.map(&:identity) == self.map(&:identity))
  end

  def all(params={})
    params["url"] ||= self.url

    response = self.connection.send(self.collection_request, params)
    load_page(response)
  end
end
