class Appfirst::Client::Server < Cistern::Model
  identity :id, type: :integer # (read-only)  Unique server ID.

  attribute :architecture,      type: :string  # (read-only) The architecture of the server.
  attribute :capacity_cpu_freq, type: :integer # (read-only) The frequency of the CPU in MHz.
  attribute :capacity_cpu_num,  type: :integer # (read-only) The number of CPU cores on the system.
  attribute :capacity_disks                    # (read-only) Mapping of the names of the disks (mount points) to their capacity in MB.
  attribute :capacity_mem,      type: :integer # (read-only) The total available memory on the server in bytes.
  attribute :created,           type: :integer # (read-only) The time the server was created in UTC seconds.
  attribute :current_version,   type: :string  # (read-only)  Version of AppFirst collector that’s running on the server.
  attribute :description,       type: :string  # The user-defined description of the server.
  attribute :distribution,      type: :string  # (read-only)  The OS distribution e.g. Ubuntu, RedHat.
  attribute :hostname,          type: :string  # (read-only)  The hostname for this server.
  attribute :kernel_version,    type: :string  # (read-only)  The specific kernel version of the server’s OS.
  attribute :location_ip,       type: :string  # (read-only)  IP address that collector is uploading from.
  attribute :nickname,          type: :string  # The user-defined nickname of the server.
  attribute :os,                type: :string  # (read-only)  The OS for this server, either Windows or Linux.
  attribute :resource_uri,      type: :string  # (read-only)  The URI to get more information about this item.
  attribute :running,           type: :boolean # (read-only) Boolean indicating whether the server is currently uploading data to AppFirst.
end
