class Appfirst::Client::ServerTag < Cistern::Model
  identity :id, type: :integer # (read-only)  Unique server tag ID.

  attribute :name,         type: :string                      # The name of the server tag.
  attribute :resource_uri, type: :string                      # (read-only)  The URI to get more information about this item.
  attribute :server_ids,   type: :array, aliases: ['servers'] # IDs of servers that belong to this server tag.

  def servers
    self.server_ids.map { |server_id| self.connection.servers.get(server_id) }
  end

  def save
    if new_record?
      self.collection.new(self.connection.create_server_tag(Cistern::Hash.slice(self.attributes, :name, :servers)).body)
    else
      raise NotImplementedError # update tag
    end
  end
end
