class Appfirst::Client
  class Real
    def create_server_tag(params={})
      request(:post, "/server_tags", params)
    end
  end # Real

  class Mock
    def create_server_tag(params={})
      identity = self.serial_id

      name    = require_parameter(params, :name, code: 5, message: "Invalid server tag name, name must be provided") # {"errors"=>[{"message"=>"Invalid server tag name, name must be provided", "code"=>5}]}
      servers = params[:servers] || []

      response_hash = {
        :id           => identity,
        :name         => name,
        :servers      => servers,
        :resource_uri => resource_uri("/server_tags/#{identity}")
      }

      self.data[:server_tags][identity] = response_hash

      response(
        :body    => response_hash,
        :status  => 200,
        :headers => {
          "Content-Type" => "application/json; charset=utf8"
        }
      )
    end
  end # Mock
end # Appfirst::Client
